* QL WORLD May 1991 - SET & ALTER  procedures
*         by       Simon N Goodwin
*
*              SET_ASM
*
*             20 APR 91
*
* 1.     Amended 4 MAR 95
*
* 2.     Amended 15th July 1999 (George Gwilt)
*        to do BP_INIT for set words
*
BV_RIP   EQU      $58
LUMP_SIZE EQU     1008
CALL_CODE EQU     20153
STRING   EQU      1
FLOAT    EQU      2
INTEGER  EQU      3
*
START    LEA      DEFINE,A1
         MOVE.W   BP_INIT,A2
         JMP      (A2)
*
DEFINE   DC.W     2                 two procs
         DC.W     SET-*
         DC.B     3,"SET"
         DC.W     ALTER-*
         DC.B     5,"ALTER"
         DC.W     0,0,0             End of fn & proc
*
HEAP_LUMP DC.W    LUMP_SIZE
SENTINEL DC.L     0
PLACE    DC.L     0                 address of BP_INITs info
*
READ_INT MOVEQ    #2,D1             space needed
         BSR      CHECKER           allocate room on the stack
         MOVE.L   (A7)+,A0          A0 -> result
         MOVE.W   (A0),(A1,A6.L)    store result
         MOVEQ    #INTEGER,D4       indicate INT result
         RTS                        D0 set to 0 by CHECKER
*
READ_PTR MOVEQ    #6,D1             space needed
         BSR      CHECKER
         MOVE.L   (A7)+,A0          A0 -> result
         MOVE.W   (A0),D3           this is even
         MOVEQ    #0,D0
         TRAP     #1                A0 -> sys vars
         MOVE.L   (A0,D3.W),D2      read system vector
         MOVE.L   D2,D1             D1 will be the exponent
         BEQ      NORMD             done - D2 = D1 = 0
SLOW_LOOP MOVE.W  #2080,D1          initial exponent
NORMALOOP SUBQ.W  #1,D1             halve exponent
         ADD.L    D2,D2             double mantissa
         BPL      NORMALOOP                  does it still fit?
         LSR.L    #1,D2             ensure sign=0 (+ve)
NORMD    MOVE.W   D1,(A1,A6.L)      exponent
         MOVE.L   D2,2(A1,A6.L)     mantissa
         MOVEQ    #FLOAT,D4                  indicate FLOAT result
         RTS
*
READ_FLT MOVEQ    #6,D1             space needed
         BSR      CHECKER
         MOVE.L   (A7)+,A0          A0 -> result
         MOVE.W   (A0)+,(A1,A6.L)   exponent
         MOVE.L   (A0),2(A1,A6.L)   mantissa
         MOVEQ    #FLOAT,D4                  indicate FLOAT result
         RTS
*
READ_STR MOVEA.L  (A7)+,A0          A0 -> address of result
         MOVEA.L  (A0),A0           address of result
         MOVEQ    #3,D1             room for length & padding . .
         ADD.W    (A0),D1           . . plus text
         BCLR     #0,D1             whole words
         BSR      CHECKER
         LSR.W    #1,D4             get count in . .
         SUBQ.W   #1,D4             . . words less 1
         MOVEA.L  A1,A2             A2 is address for answer
COPY_TEXT MOVE.W  (A0)+,(A2,A6.L)   store . .
         ADDQ.L   #2,A2             . . the . .
         DBF      D4,COPY_TEXT      . . string
GOT_STRG MOVEQ    #STRING,D4                 mark STRING result
         RTS
*
CHECKER  MOVE.L   D1,D4             save size
         TST.B    $54(A6)           could it be Turbo? . .
         BPL      FND_ROOM1                  . . no
         CMPI.L   #"SBAS",-4(A6)    Really compiled? . .
         BNE      FND_ROOM          . . yes
FND_ROOM1 MOVEA.W BV_CHRIX,A1       check space
         JSR      (A1)
FND_ROOM MOVE.L   BV_RIP(A6),A1
         SUBA.L   D4,A1             grab the bytes . .
         MOVE.L   A1,BV_RIP(A6)     . . and update BV_RIP
         MOVEQ    #0,D0
         RTS
*
* (SET [#] unset_name / ALTER "name_text") TO value - parse parameters
*
ALTER    MOVEQ    #-1,D5            D5.L is -ve for ALTER
         BRA      PARMS
SET      MOVE.L   PLACE,D5          Is there space for BP_INIT info? . .
         BNE      SET_1             . . yes
         TRAP     #0                Supervisor mode
         MOVEQ    #42,D1            space needed from the user heap
         MOVE.L   D1,D4             repeat in D4 for BALLOC
         MOVEA.L  A3,A4             keep A3 . .
         BSR      BALLOC            A0 -> space
         MOVEA.L  A4,A3             . . and restore A3
         LEA      PLACE,A2          put address of space . .
         MOVE.L   A0,(A2)           . . in PLACE
         CLR.L    (A0)+             mark no procedures (0,0)
         MOVE.W   #4,(A0)           mark 1 function (allow 31-byte name)
         ANDI     #$D8FF,SR                  back to user mode
SET_1    MOVEQ    #1,D5             mark SET
PARMS    LEA      16(A3),A4                  check for . .
         CMPA.L   A4,A5             . . two . .
         BNE      BAD_PARM2                  . . parameters
*
* If TURBO compiled set A4 equal to Master Basic's A6,
* else set A4 equal to the A6 of the basic we are in.
*
         TST.B    $54(A6)           -ve is either TURBO or SBASIC
         BPL      SET_2
         CMPI.L   #'SBAS',-4(A6)
         BEQ      SET_2
         MOVEQ    #0,D2
         MOVEQ    #0,D1
         MOVEQ    #MT_JINF,D0
         TRAP     #1
         MOVEA.L  JB_A6-$68(A0),A4
         BRA      SET_3
SET_2    MOVEA.L  A6,A4
SET_3    TST.L    D5                is this ALTER? . .
         BMI      LOOKUP            . . yes
         MOVE.B   1(A3,A6.L),D5     get parameter type
         BEQ      BAD_PARM2                  don't want this!
         BTST     #7,D5             is it #? . .
         BEQ      NORM_SET          . . no
         MOVEQ    #0,D5             mark vector
NORM_SET MOVE.B   (A3,A6.L),D1      get name type
         BEQ      NOTYETSET
*
BAD_PARM2 MOVEQ   #-15,D0
BAD_EXIT2 RTS
*
LOOKUP   LEA      8(A3),A5          isolate the 1st parameter
         MOVE.L   A5,D7             keep the place
         MOVE.W   CA_GTSTR,A0
         JSR      (A0)              get a string
         BNE      BAD_EXIT2 ---->
         MOVE.W   (A1,A6.L),D0
         BEQ      BAD_PARM2                  don't want zero strings
         MOVE.W   D0,D1             keep length
         LEA      2(A1),A5          -> text
*
* Convert to upper case
*
         MOVEQ    #-33,D2
LOCK_CASE AND.B   D2,2(A1,A6.L)
         ADDQ.L   #1,A1
         SUBQ.W   #1,D0
         BNE      LOCK_CASE
*
* Work out data type to be SET
*
         MOVE.B   1(A1,A6.L),D3     get last character of name
         MOVEQ    #STRING,D5                 assume type string
         CMP.B    #"$"-32,D3                 is it "$" . .
         BEQ      TYPE_CAST                  . . yes, a string
         MOVEQ    #INTEGER,D5       set integer
         CMP.B    #"%"-32,D3                 is it "%"? . .
         BEQ      TYPE_CAST                  . . yes
         MOVEQ    #FLOAT,D5                  must be float
TYPE_CAST
         TRAP     #0
         MOVEA.L  24(A4),A0                  A0 -> Name Table Start
         MOVE.L   28(A4),D0                  D0 -> Name Table End
         MOVE.L   32(A4),D3                  D3 -> Name List Start
NEXT_NAME MOVEA.W 2(A0,A4.L),A3     A3.L is the offset in NL
         ADDA.L   D3,A3             (A3,A4.L) -> name
         CMP.B    (A3,A4.L),D1      correct length? . .
         BEQ      GOT_LNGTH                  . . yes
ADV_NL   ADDQ.L   #8,A0             to next Name Table entry . .
         CMP.L    A0,D0             . . till finished . .
         BHI      NEXT_NAME                  . . not yet
         MOVEQ    #-7,D0            Not there!
         BRA      SPR_STOP
*
* See if name is right
*
GOT_LNGTH MOVE.B  1(A3,A4.L),D4
         AND.B    D2,D4             see case is the same
         CMP.B    (A5,A6.L),D4
         BNE      ADV_NL            mismatch, try again
         MOVE.W   D1,D6             residual length
         SUBQ.W   #2,D6             for DBNE
         BMI      FOUND_IT          found name, length one
         MOVEA.L  A5,A1
CHK_NAME MOVE.B   2(A3,A4.L),D4
         AND.B    D2,D4             convert case
         ADDQ.L   #1,A3             step thru Name List
         ADDQ.L   #1,A1             step thru parameter
         CMP.B    (A1,A6.L),D4
         DBNE     D6,CHK_NAME
         BNE      ADV_NL            not yet found
FOUND_IT CMPI.B   #9,(A0,A4.L)
         BEQ      LOOKUP_OK                  it's resident FN
IN_USE   MOVEQ    #-9,D0            report "in use"
         BRA      SPR_STOP
*
LOOKUP_OK
         ANDI     #$D8FF,SR
         MOVEA.L  D7,A3             D7 points past parameter 1
         LEA      8(A3),A5          A3 & A5 bracket parameter 2
         MOVE.L   A0,D7             offset to Name Table entry
         LEA      READ_PTR,A2
         MOVEA.L  4(A0,A4.L),A0     address of input code? . .
         MOVE.L   2(A0),D4
         CMP.L    A2,D4
         BNE      GOT_NAME          . . is not READ_PTR
         MOVEQ    #-1,D5            mark . .
         CLR.W    D5                . . vector
         BRA      GOT_NAME
*
BAD_PARAM MOVEQ   #-15,D0
BAD_EXIT RTS
*
NOTYETSET MOVE.W  2(A3,A6.L),D7     get parameter name NT index
         BLE      BAD_PARAM
         EXT.L    D7
         LSL.L    #3,D7             scale for 8-bytes entries
         ADD.L    24(A6),D7                  add offset to NT
NEXT_PARM ADDQ.L  #8,A3             to next parameter
*
* A4 to SuperBASIC or SBASIC A6, A3 & A5 -> parameter 2, D7.L is
* NT entry offset, D5.B is data-type 1-3 or 0 for vector D5.L is
* -ve for ALTER vector.
*
GOT_NAME AND.B    #15,D5            keep data-type bits . .
         MOVE.B   D5,D4             . . and in D4
         BNE      NOT_VECTR
         MOVEQ    #3,D4             set vector to integer type
NOT_VECTR EXT.W   D4
         ADD.W    D4,D4             type is now 2, 4 or 6
         SUBA.L   A0,A0
         SUBA.W   D4,A0
         MOVEA.W  $118(A0),A0       get the right QDOS vector
         JSR      (A0)              put parameter on stack
         BNE      BAD_EXIT ---->
*
* is it a pre-existing function?
*
         TST.B    (A4,D7.L)                  has it a value? . .
         BEQ      NEOPHYTE          . . no
         MOVEA.L  4(A4,D7.L),A0     A0 -> the code
         CMPI.W   #CALL_CODE,(A0)+  was it SET? . .
         BNE      BAD_PARAM ---->   . . no
         CMP.B    #1,D5             string type? . .
         BNE      OLD_SCALR                  . . no
*
* String : deallocate and re-allocate if need be.
*
         LEA      4(A0),A3          A3 -> data handle
         MOVEA.L  (A3),A0           find current data area
         MOVE.L   -4(A0),D1                  find maximum space for text here
         SUBQ.L   #6,D1             ignore first 6 bytes
         CMP.W    (A1,A6.L),D1      will new text fit? . .
         BCC      STR_FITS          . . yes
*
* De-allocate old space and get new
*
         TRAP     #0
         MOVE.W   #16,-8(A3)                 shrink the descriptor
         ADDQ.L   #6,D1             plus room for the lengths
         MOVE.L   A3,D7             keep data pointer
         SUBQ.L   #4,A0             step back to heap block length
         LEA      SENTINEL,A1
         MOVE.W   MM_LNKFR,A2
         JSR      (A2)              release space
         MOVEQ    #1,D1             byte to get size started
         MOVEQ    #-1,D5            special type for ALTERed strings
         MOVE.L   BV_RIP(A6),A1
         BRA      NEW_STRG          store the ALTERed text
*
STR_FITS MOVEQ    #1,D4             allow for an odd byte length
         ADD.W    (A1,A6.L),D4
         LSR.W    #1,D4             get number of words for DBF
         BRA      RE_SET
*
* new value to scalar slot
*
OLD_SCALR ADDQ.L  #4,A0             skip the code address
         MOVEQ    #2,D4             count for DBF
         CMP.B    #FLOAT,D5                  float? . .
         BEQ      RE_SET            . . yes
         MOVEQ    #0,D4             count for DBF
         TST.L    D5                is it a vector? . .
         BPL      RE_SET            . . no
         BTST     #0,1(A1,A6.L)     is number even? . .
         BNE      BAD_PARAM ---->   . . no, so error
RE_SET
         TRAP     #0
DATA_STR BSR      DATS
*
SPR_STOP
         ANDI     #$D8FF,SR
         RTS
*
NEOPHYTE
         TRAP     #0
         MOVEQ    #16,D1            size = 4(LEN) + 6(JMP) + 6?(DATA)
         CMP.B    #STRING,D5                 string? . .
         BEQ      NEW_STRG          . . yes
         CMP.B    #FLOAT,D5                  float? (6 bytes) . .
         BEQ      SPACE_SET                  . . yes
         MOVEQ    #12,D1            for integer size is 4+6+2
         BRA      SPACE_SET
*
BALLOC   LEA      SENTINEL,A0
         MOVE.W   MM_ALLOC,A2
         JSR      (A2)
         TST.L    D0
         BNE      FIND_MORE
         RTS
;
NEW_STRG ADDQ.L   #6,D1             allow for string spacer & long header
         ADD.W    (A1,A6.L),D1
SPACE_SET MOVE.L  D1,D4
ALLOC_D1 BSR      BALLOC            A0 -> D1 bytes
         BRA      COUNT_UP
;
FIND_MORE MOVEA.W HEAP_LUMP,A0
         MOVE.L   D4,D1             space needed
         CMP.L    A0,D1             Will it fit the next lump? . .
         BHI      GET_PLNTY                  . . no
         MOVEQ    #0,D1
GET_PLNTY ADD.L   A0,D1             new space needed
         MOVEQ    #0,D2
         MOVEQ    #MT_ALCHP,D0
         TRAP     #1
         TST.L    D0
         BNE      SPR_STOP ---->    OOPS!
         MOVEQ    #16,D2            forget the 16-bytes ALCHP header
         SUB.L    D2,D1             D1 is the size available
         LEA      SENTINEL,A1
         MOVE.W   MM_LNKFR,A2
         JSR      (A2)              link in new space
         MOVE.L   D4,D1             space originally needed
         BRA      BALLOC            go back and get it
*
BAD_VECTR MOVEQ   #-15,D0
         BRA      SPR_STOP
*
MAKE_PTR BTST     #0,1(A1,A6.L)     check it's an even word
         BNE      BAD_VECTR ---->
         LEA      READ_PTR,A2
         BRA      WORD_CNT
*
MAKE_NUMS LEA     READ_INT,A2       point to integer code
         CMP.B    #INTEGER,D5       integer? . .
         BEQ      WORD_CNT          . . yes
         LEA      READ_FLT,A2       must be FLOAT
         BRA      WORD_CNT
*
COUNT_UP MOVEA.L  BV_RIP(A6),A1     get stack
         TST.B    D5                string? . .
         BPL      MAKE_CODE                  . . no
         MOVEA.L  D7,A2             A2 -> code to do string
         ADDQ.L   #4,A0             step past extension entry length
         MOVE.L   A0,(A2)           Make handle point at new text
         LSR.W    #1,D4             count in words
         SUBQ.L   #3,D4             discard 2 prefix words & 1 for DBF
         BRA      DATA_STR
*
MAKE_CODE CMP.B   #STRING,D5                 check data-type
         BCS      MAKE_PTR          vector
         BHI      MAKE_NUMS                  FLOAT or INTEGER
         LEA      READ_STR,A2       A2 -> string code
         SUB.W    #9,D4             round up & forget extra string data
WORD_CNT LSR.W    #1,D4             count words
         SUBQ.W   #6,D4             discard 5 prefix words & 1 for DBF
MAKE_VAL MOVE.L   (A0)+,D1          total heap block length
         MOVE.L   A0,D3             keep address for BP_INIT later
         MOVE.W   #CALL_CODE,(A0)+  store JSR instruction
         MOVE.L   A2,(A0)+          store the address of the data fetcher
         SUBQ.B   #STRING,D5                 string? . .
         BNE      MAKE_VAL1                  . . no
         LEA      10(A0),A2                  find address of string . .
         MOVE.L   A2,(A0)+          . . and put it in
         ADDQ.L   #2,A0             skip to next user heap block
         MOVEQ    #16,D2            size of the 1st part
         SUB.L    D2,D1             D1 is the size of the remaining part
         MOVE.L   D1,(A0)+          store block size of part 2
MAKE_VAL1 BSR     DATS              copy data
*
* Now make up the data for BP_INIT
*
         MOVEA.L  PLACE,A5          get address of BP_INIT data
         LEA      6(A5),A5          place for relative word pointer
         SUB.L    A5,D3             calculate the word value . .
         MOVE.W   D3,(A5)           . . and put it in
         MOVE.W   2(A6,D7.L),D2     pointer to new SET name
         MOVEA.L  $20(A6),A0                 base of name list . .
         ADDA.W   D2,A0             . . . plus offset
         LEA      (A0,A6.L),A0      A0 -> name
         MOVEQ    #0,D1
         MOVE.B   (A0),D1           count to D1.W
         ADDQ.W   #2,D1             +1 for count, +1 for rounding
         BCLR     #0,D1
         LEA      2(A5),A1          place for the SET name to go
         BRA      NME1
NME2     MOVE.B   (A0)+,(A1)+
NME1     DBF      D1,NME2
         CLR.W    (A1)              mark end of functions
         MOVE.L   PLACE,A1          set A1 for BP_INIT
         EXG      A4,A6             keep A6 and set Master Basic if needed
         MOVEA.W  BP_INIT,A2
         JSR      (A2)              link in to SuperBASIC or SBASIC
         EXG      A4,A6             replace true A6
         MOVEQ    #0,D0             ... and that's it folks
         BRA      SPR_STOP
;
DATS     MOVE.W   (A1,A6.L),(A0)+   insert data from stack
         ADDQ.L   #2,A1
         DBF      D4,DATS
         RTS
